# Better CLI tools

- **What**: What is the tool for
- **OG**: Original tool
- **Better**: Better tool to use
- **Lang**: Language the tool is written in
- **Multi**: Works on all major platforms (Windows, Linux, Mac, \*BSD)

| What                      | OG       | Better    | Lang | Multi         | How to install                     |
| ------------------------- | -------- | --------- | ---- | ------------- | ---------------------------------- |
| Find text in files        | grep     | [ripgrep] | Rust | ✔️            | `cargo install ripgrep`            |
| List files in a directory | ls       | [exa]     | Rust | ❌<sup>1</sup> | `cargo install exa`                |
| Read file content         | cat      | [bat]     | Rust | ✔️            | Package manager (+ choco)          |
| Find files by name        | find     | [fzf]     | Go   | ✔️            | Package manager (+ choco)          |
| Count lines of code       | cloc     | [loc]     | Rust | ✔️            | `cargo install loc`                |
| Navigate/manipulate JSON  | _N/A_    | [jq]      | C    | ✔️            | Package manager (+ choco)          |
| Navigate/manipulate HTML  | _N/A_    | [pup]     | Go   | ✔️            | `go get github.com/ericchiang/pup` |
| Static HTTP file server   | _[many]_ | [ran]     | Go   | ✔️            | `go get -u github.com/m3ng9i/ran`  |

[ripgrep]: https://github.com/BurntSushi/ripgrep
[loc]: https://github.com/cgag/loc
[bat]: https://github.com/sharkdp/bat
[jq]: https://stedolan.github.io/jq/
[pup]: github.com/ericchiang/pup
[fzf]: https://github.com/junegunn/fzf
[exa]: https://the.exa.website/
[many]: https://gist.github.com/willurd/5720255
[ran]: https://github.com/m3ng9i/ran

1. `exa` doesn't compile on Windows
